#include <time.h>
#include "cgichk.h"

/*----------------------------------------------------------------*/
void waitafew(int del)
{
  clock_t  prevtime = clock();

  while(1)
    {
      if ((clock() - prevtime) >= (CLOCKS_PER_SEC * del)) return;
    }
}
/*----------------------------------------------------------------*/
void PRINT(char *arg, ...)
{
  va_list v;
  char *buff;

  buff = (char*)malloc(8192);

  va_start(v, arg);
  vsprintf(buff, arg, v);
  va_end(v);

  fprintf(OUTPUT, "%s", buff);
  fflush(OUTPUT);
  free(buff);
}
/*----------------------------------------------------------------*/
void CPRINT(char *arg, ...)
{
  va_list v;
  char *buff;

  if (OUTPUT != stdout) return;

  buff = (char*)malloc(8192);

  va_start(v, arg);
  vsprintf(buff, arg, v);
  va_end(v);

  printf("%s", buff);
  fflush(OUTPUT);
  free(buff);
}

/*----------------------------------------------------------------*/
void breakup_url(char *url, char *base, char *dir, unsigned int *port)
{
  char *a, *b, *p;

  if ((!url) || (!base) || (!dir) || (!port)) return;

  a = (char*)strstr(url, "://");
  if (a)  a+=3;                  // skip http://
    else  a = url;


                                 //FIXME: ports normally come after the
                                 //       domain name in URL's, not after dir
  p = (char*)strchr(a, ':');     // look for port number
  if (p)
    {
      *port = atoi(p+1);
    }
      else
    {
      *port = 80;
    }

  b = (char*)strchr(a, '/');     // look for first directory slash, if any
  if (b)                         // has it
    {
      memcpy(base, a, b-a);
      a = b;
      if (p)
        {
          memcpy(dir, a, p - a);
        }
          else
        {
          memcpy(dir, a, strlen(a));
        }
    }
      else                // doesn't have it
    {
      if (p)
        {
          memcpy(base, a, p - a);
        }
          else
        {
          memcpy(base, a, strlen(a));
        }
    }
}
